unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.Grids, system.UITypes,
  Vcl.ExtCtrls, Velthuis.BigIntegers, Velthuis.BigDecimals;

type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    StringGrid1: TStringGrid;
    StringGrid2: TStringGrid;
    LabeledEdit1: TLabeledEdit;
    BitBtn2: TBitBtn;
    RadioGroup1: TRadioGroup;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    CheckBox1: TCheckBox;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
  private
    { Private 錾 }
    function LUecomposition: byte;
    procedure GridSet(Sin, Colin: integer);    // ObhTCYύX
    procedure testset;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}


var
  Nltest : integer = 4;             // eXgf[^[s
                                    // eXgf[^[
  mattestA : array[0..3] of array[0..3] of extended = ((8, 16, 24, 32),
                                                       (2,  7, 12, 17),
                                                       (6, 17, 32, 59),
                                                       (7, 22, 46,105));
  mattestB : array[0..3] of array[0..3] of extended = ((8, 16, 24,  32),
                                                       (2,  7, 12,  17),
                                                       (2, 17, 32,   0),
                                                       (7,  0,  0, 105));
  mattestC : array[0..3] of array[0..3] of extended = (( 8, 34, 24,  32),
                                                       ( 2,  7,  0,   0),
                                                       (24, 17,  0,   0),
                                                       ( 7,  0,  0,   0));
  mattestD : array[0..3] of array[0..3] of extended = ((0,  16, 24,  32),
                                                       (2,  7, 12,  17),
                                                       (6, 17, 32,   0),
                                                       (7,  0,  0, 105));
  mattestE : array[0..3] of array[0..3] of extended = ((0,  0,  0,  32),
                                                       (0,  0, 12,  17),
                                                       (6, 17, 32,   0),
                                                       (7,  0,  0, 105));
  btestA    : array[0..3] of extended = (160, 70, 198, 291);
  btestB    : array[0..3] of extended = (150, 60, 10, 40);

  Nl : integer;                       // s
  aa   : array of array of bigdecimal;  // Zpaz
  a    : array of array of bigdecimal;  // Zpaz
  b    : array of bigdecimal;           // Zpbs
  p : array of integer;                 // sړ
  dpcs : integer;

  allowable_errorr : bigdecimal;

// Obh̐ݒ
procedure TForm1.GridSet(Sin, Colin: integer);    // ObhTCYύX
var                                               // f[^[s̐10
  H, W, i :integer;                               // ȏ̓XN[
begin
  inc(Sin);
  inc(Colin);
  StringGrid1.ColCount := Colin;
  StringGrid1.RowCount := Sin;
  if Sin <= 11 then                               // XgOObh̑傫ݒ
    begin                                         // Œs܂11s͂ȉ̏ꍇ
      H := (StringGrid1.DefaultRowHeight + 1) * Sin;
      StringGrid2.ScrollBars := ssNone;           // XN[o[\
    end
    else
    begin                                         // Œs܂11s葽ꍇ
      H := (StringGrid1.DefaultRowHeight + 1) * (10 + 1);
      StringGrid2.ScrollBars := ssVertical;       // XN[o[\
    end;
  if Colin <= 11 then                             // XgOObh̑傫ݒ
    begin                                         // Œs܂11s͂ȉ̏ꍇ
      W := (StringGrid1.DefaultColWidth + 1) * Colin;
      StringGrid1.ScrollBars := ssNone;           // XN[o[Ȃ
    end
    else
    begin                                         // Œs܂11s葽ꍇ
      W := (StringGrid1.DefaultColWidth + 1) * (10 + 1);
      StringGrid1.ScrollBars := ssBoth;           // XN[o[\
    end;
  StringGrid1.ClientWidth := W;
  StringGrid1.ClientHeight := H;
  for i := 1 to Sin - 1 do StringGrid1.Cells[0,i] := 'a' + intTostr(i) + '*';
  for i := 1 to Sin - 1 do StringGrid1.Cells[i,0] := 'a*' + intTostr(i);
  StringGrid2.RowCount := Sin;
  StringGrid2.ClientHeight := H + 1;
  StringGrid2.ClientWidth := (StringGrid2.DefaultColWidth + 1) * 2;
  for i := 1 to Sin - 1 do StringGrid2.Cells[0, i] := intTostr(i);
  StringGrid2.Cells[1, 0] := 'b*=';
end;

// KEX̏@ɂẢ@ LU
function TForm1.LUecomposition: byte;
const
  sp = ' ';
var
  i, j, k, n, pivot, pt: integer;
  sum, tmp, amax : bigdecimal;
  x, y : array of bigdecimal;
  LL, spl : string;
begin
  setlength(a, Nl, Nl);
  setlength(x, Nl);
  setlength(y, Nl);
  setlength(p, Nl);

  memo1.Clear;

  // matA, bf[^[ҏWpbigdecimalɃRs[
  // a̒l͕ωĂ܂
  for j := 0 to Nl - 1 do begin
    for k := 0 to Nl - 1 do begin
      a[j, k] := aa[j, k];
    end;
  end;

  // sւno
  for i := 0 to Nl - 1 do p[i] := i;         // sԍ0`N - 1

  // LU Oi
  for k := 0 to Nl - 2 do begin
    pivot := k;                              // s{bg̑I
    amax := bigdecimal.abs(a[pivot, pivot]);            // K̍s̍ől
    for i := pivot + 1 to Nl - 1 do begin    // s{bg̎̍s
      if bigdecimal.abs(a[i, k]) > amax then begin
        pivot := i;
        amax := bigdecimal.abs(a[pivot, k]);
      end;
    end;
    if pivot <> k then begin                 // őlsւ
      for i := 0 to Nl - 1 do begin
        tmp := a[k, i];
        a[k, i] := a[pivot, i];
        a[pivot, i] := tmp;
      end;
      pt := p[k];                            // sԍ
      p[k] := p[pivot];
      p[pivot] := pt;
    end;
    // LU decomposition  right-looking algorithm
    for i := k + 1 to Nl - 1 do begin
      if a[k, k] = 0 then begin               // ΊpɃ[I
        result := 1;
        exit;
      end;
      a[i, k] := a[i, k] / a[k, k];           // L
      for j := k + 1 to Nl - 1 do a[i, j] := a[i, j] - a[i, k] * a[k, j];   // U
    end;
  end;

  // b̒lZbg
  for i := 0 to Nl - 1 do x[i] := b[p[i]];    // sւnoɂxb̒lZbg

  // Oi
  for i := 1 to Nl - 1 do
    for j := 0 to i - 1 do x[i] := x[i] - a[i, j] * x[j];

  // ޑ
  for i := Nl - 1 downto 0 do begin
    for j := i + 1 to Nl - 1 do x[i] := x[i] - a[i, j] * x[j];
    if a[i, i] = 0 then begin                // Ίp[I
      result := 1;
      exit;
    end;
    x[i] := x[i] / a[i, i];
  end;

  // es̍vZ
  for j := 0 to Nl - 1 do begin
    sum := 0;
    for i := 0 to Nl - 1 do begin
      sum := sum +  aa[j, i] * x[i];      // aa[]̒lgp܂B
    end;
    y[j] := b[j] - sum;                   // 
  end;
  LL := 'vZ@';
  for i := 0 to Nl - 1 do begin
    if i < NL - 1 then LL := LL + intTostr(p[i] + 1) + ','
                  else LL := LL + intTostr(p[i] + 1);
  end;
  memo1.Lines.Append(LL);

  // sԍ\
  memo1.Lines.Append('s No     Zɂ鍷');
  for k := 0 to Nl - 1 do begin
    LL := 'No = ' + inttostr(k + 1);
    n := 10 - length(LL);
    spl := '';
    for j := 1 to n do spl := spl + sp;
    memo1.Lines.Append(LL + spl + y[k].ToString);
  end;

  // 덷̊mF 덷傫ꍇZrΊp̒l[ɋ߂lɂȂĂ܂B
  j := 0;           // 덷̐
  for k := 0 to Nl - 1 do begin
    if bigdecimal.abs(b[k]) > allowable_errorr then amax := y[k] / b[k]               // 덷䗦
                                               else amax := y[k];
    if bigdecimal.abs(amax) > allowable_errorr then inc(j);
  end;
  if checkbox1.Checked = false then
    if j > 0 then begin
      memo1.Lines.Append('Z   NG');
      result := 1;
      exit;
    end
    else
      memo1.Lines.Append('Z   OK');

  // x̒l\
  for k := 0 to Nl - 1 do begin
    x[k] := x[k].RemoveTrailingZeros(0);
    memo1.Lines.Append('X' + inttostr(k + 1) + '=' + x[k].ToString);
  end;
  result := 0;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  i, j, ch: integer;
  matA : array of array of extended;  // Asz ̓`FbNp Zɂ͎gpȂ
  matB : array of extended;           // Asz ̓`FbNp Zɂ͎gpȂ
  maxb, minb, bc, epsilon : bigdecimal;
  LL : string;
  acmax : array of bigdecimal;
  acmin : array of bigdecimal;
begin
  setlength(matA, Nl, Nl);
  setlength(aa, Nl, Nl);
  setlength(matB, Nl);
  setlength(b, Nl);
  setlength(acmax, Nl);
  setlength(acmin, Nl);

  // matAɃObh1lǂݍ
  for i := 0 to Nl - 1 do
    for j := 0 to Nl - 1 do begin
      val(StringGrid1.Cells[i + 1,j + 1],matA[j,i], ch);
      if ch <> 0 then begin
        MessageDlg('a' + intTostr(j + 1) + ',' + intTostr(i + 1) + ' ̓͒l' + intTostr(ch) + 'ڂɌ肪L܂B', mtInformation,[mbOk], 0);
        exit;
      end;
    end;
  // bɃObh2lǂݍ
  for i := 0 to Nl - 1 do begin
    val(StringGrid2.Cells[1, i + 1], matB[i], ch);
    if ch <> 0 then begin
      MessageDlg('b' + intTostr(i + 1) + '̓͒l' + intTostr(ch) + 'ڂɌ肪L܂B', mtInformation,[mbOk], 0);
      exit;
    end;
  end;
  // bigdecimal̔zɓǂݍ
  for i := 0 to Nl - 1 do begin
    b[i] := StringGrid2.Cells[1, i + 1];
    for j := 0 to Nl - 1 do begin
      aa[j, i] := StringGrid1.Cells[i + 1,j + 1];
    end;
  end;

  val(labelededit2.Text, dpcs, ch);
  if ch <> 0 then begin
    MessageDlg('L͒l' + intTostr(ch) + 'ڂɌ肪L܂B', mtInformation,[mbOk], 0);
    exit;
  end;
  if dpcs < 5 then begin
    MessageDlg('L̒l܂B', mtInformation,[mbOk], 0);
    exit;
  end;
  if dpcs > 60 then begin
    MessageDlg('L̂60ɂĂB', mtInformation,[mbOk], 0);
    exit;
  end;
  // 덷̋e͈͓ǂݍ
  val(labelededit3.Text, matB[0], ch);
  if ch <> 0 then begin
    MessageDlg('e덷' + intTostr(ch) + 'ڂɌ肪L܂B', mtInformation,[mbOk], 0);
    exit;
  end;
  if matB[0] > 10 then begin
    MessageDlg('e덷̒l傫܂B', mtInformation,[mbOk], 0);
    exit;
  end;
  if matB[0] <= 0 then begin
    MessageDlg('e덷̓[傫ĉB', mtInformation,[mbOk], 0);
    exit;
  end;
  allowable_errorr := labelededit3.Text;
  // epsilonLݒ
  LL := '1e-' + intTostr(dpcs - 1);
  epsilon := LL;
  // As̍őlŏl
  for i := 0 to Nl -1 do begin
    acmax[i] := 1;
    acmin[i] := 1;
    if aa[i, 0] <> 0 then acmax[i] := bigdecimal.abs(aa[i, 0]);
    if aa[i, 0] <> 0 then acmin[i] := bigdecimal.abs(aa[i, 0]);
    for j := 1 to Nl - 1 do begin
      if (bigdecimal.abs(aa[i, j]) > acmax[i]) and (aa[i, j] <> 0) then acmax[i] := bigdecimal.abs(aa[i, j]);
      if (bigdecimal.abs(aa[i, j]) < acmin[i]) and (aa[i, j] <> 0) then acmin[i] := bigdecimal.abs(aa[i, j]);
    end;
  end;
  // BsAs̔ŏlƍől
  maxb := bigdecimal.abs(b[0]) / acmax[0];
  minb := bigdecimal.abs(b[0]) / acmin[0];
  for i := 1 to Nl - 1 do begin
    if bigdecimal.abs(b[i]) / acmax[i] > maxb then maxb := bigdecimal.abs(b[i]) / acmax[i];
    if bigdecimal.abs(b[i]) / acmin[i] < minb then minb := bigdecimal.abs(b[i]) / acmin[i];
  end;
  if minb > 1 then minb := 1 / minb;
  if maxb < 1 then maxb := 1 / maxb;
  // b̒l͈̔͂Z͈̔͂zĂ邩
  bc := minb;
  if (minb = 0) and (maxb > 0) then
    if maxb >= 1 then bc := 1 / maxb
                 else bc := maxb;
  if (minb > 0) and (maxb > 0) then bc := minb / maxb;
  if (minb = 0) and (maxb = 0) then bc := 1;
  if checkbox1.Checked = false then
    if bc  < epsilon then begin
      MessageDlg('b̓͒l̒lZ͈̔͂𒴂Ă܂B', mtInformation,[mbOk], 0);
      memo1.Clear;
      exit;
    end;
  // Zʂ̔lݒ
  allowable_errorr := allowable_errorr * bigdecimal.Sqrt(bc, dpcs * 2);

  bigdecimal.DefaultPrecision := dpcs;

  // Ả@  @łȂꍇ
  j := LUecomposition;
  if (j = 0) or (j = 2) then exit;       // Ίpl 0 ȂI
  // @oȂ
  if j = 1 then begin
    MessageDlg('@Ίp[A[ɋ߂l܂A͒lĉB' + #13#10
              + 'LsĂꍇ܂B' + #13#10
              + 'Lꍇ́Ae덷̒lĉB', mtInformation,[mbOk], 0);
    exit;
  end;
end;

// eXgf[^[̑Iݒ
procedure TForm1.testset;
var
  i, j : integer;
begin
  GridSet(Nltest, Nltest);
  Nl := Nltest;
  for i := 1 to Nltest do
    for j := 1 to Nltest do begin
      case RadioGroup1.ItemIndex of
        0: StringGrid1.Cells[i,j] := floatTostr(mattestA[j-1, i-1]);
        1: StringGrid1.Cells[i,j] := floatTostr(mattestB[j-1, i-1]);
        2: StringGrid1.Cells[i,j] := floatTostr(mattestC[j-1, i-1]);
        3: StringGrid1.Cells[i,j] := floatTostr(mattestD[j-1, i-1]);
        4: StringGrid1.Cells[i,j] := floatTostr(mattestE[j-1, i-1]);
      end;
    end;
  for i := 1 to Nltest do begin
    case RadioGroup1.ItemIndex of
      0: StringGrid2.Cells[1,i]  := floatTostr(btestA[i-1]);
      1, 2, 3, 4: StringGrid2.Cells[1,i]  := floatTostr(btestB[i-1]);
    end;
  end;
  LabeledEdit1.Text := intTostr(Nltest);
  memo1.Clear;
end;

// ObhTCY̕ύX
procedure TForm1.BitBtn2Click(Sender: TObject);
var
  ch : integer;
begin
  val(LabeledEdit1.Text, Nl, ch);
  if ch <> 0 then begin
    MessageDlg('N̓͒l' + intTostr(ch) + 'ڂɌ肪L܂B', mtInformation,[mbOk], 0);
    exit;
  end;
  GridSet(Nl, Nl);
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  testset;
end;

// l̐ݒ
procedure TForm1.FormCreate(Sender: TObject);
begin
  testset;
end;

end.
